// Definizione e testing una funzione che restituisce il
// massimo di una sequenza non vuota di numeri interi non
// negativi terminata da un intero negativo.

// inclusione dell'header file della libreria standard di
// definizioni di macro, costanti e dichiarazioni di funzioni e tipi
// per le varie operazioni di input/output

#include <stdio.h>

// Definizione di una funzione che calcola il massimo tra 2 valori
// interi
int massimoTraDue (int x, int y)
   {
   // Parametri formali
   //    x:      primo valore
   //    y:      secondo valore
   
   // determino e restituisco il massimo tra i due valori
   if (x>y)
     return(x);
   else
     return(y);
   }

// Definizione della funzione
int massimoSeq()
   {
   // variabile per il massimo corrente;
   int max;

   // variabile per i valori della sequenza
   int valore;

   // acquisisco il primo valore
   printf("\nDammi il primo valore: ");
   scanf("%d", &valore);

   // inizializzo il massimo con il primo valore acquisito.
   // Potrei inizializzarlo con 0, il minimo valore che puo'
   // comparire nella squenza, ma la soluzione sarebbe meno
   // generale
   max = valore;

   // continuo fino al primo valore
   // negativo
   while (valore >= 0)
      {
	  // acquisisco il prossimo valore
      printf("\nDammi il prossimo valore: ");
      scanf("%d", &valore);
	  
	  // aggiorno il valore del massimo corrente
      max = massimoTraDue (max, valore);
      };

   // restituisco il valore del massimo coorente
   // che coincide con quello del massimo nella sequenza
   return(max);
   }

// Testing della funzione

int main()
   {
   // calcolo e visualizzo il massimo valore della sequenza
   printf ("\nIl massimo valore della sequenza e' %d \n", massimoSeq());

   return(1);
   }
 